﻿using HarmonyLib;
using Steamworks;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using UnityEngine;

public class HatsMod : Mod
{
    AssetBundle asset;
    private readonly string harmonyId = "fr.tekgamer.hatsmod";
    private Harmony harmonyInstance;
    public static Dictionary<Item_Base, GameObject> hats = new Dictionary<Item_Base, GameObject>();

    public static ObjectSpawnerManager spawner;
    public static ObjectSpawnerAssetSettings SpawnerSettings;

    public static float spawnChance = 0.8f;

    public static Dictionary<Item_Base, SpawnableFloatingObject> spawnableObjects = new Dictionary<Item_Base, SpawnableFloatingObject>();

    public IEnumerator Start()
    {
        HNotification notification = FindObjectOfType<HNotify>().AddNotification(HNotify.NotificationType.spinning, "Loading Hats...");

        harmonyInstance = new Harmony(harmonyId);
        harmonyInstance.PatchAll(Assembly.GetExecutingAssembly());

        AssetBundleCreateRequest request = AssetBundle.LoadFromMemoryAsync(GetEmbeddedFileBytes("hatsmod.assets"));
        yield return request;

        asset = request.assetBundle;
        Item_Base mcph = asset.LoadAsset<Item_Base>("mcph_so");
        spawnableObjects.Add(mcph, new SpawnableFloatingObject()
        {
            uniqueIndex = 4,
            hasNetworkBehaviour = true,
            recieveOnSpawnMessage = false,
            typeToSpawn = ObjectSpawnType.GameObject,
            prefab = asset.LoadAsset<GameObject>("Pickup_Hat_PigHead"),
            minRotation = new Vector3(0, 0, 0),
            maxRotation = new Vector3(360, 360, 360),
            spawnChance = spawnChance
        });
        RAPI.RegisterItem(mcph);
        hats.Add(mcph, asset.LoadAsset<GameObject>("mcph_prefab"));

        Item_Base mcsh = asset.LoadAsset<Item_Base>("mcsh_so");
        RAPI.RegisterItem(mcsh);
        spawnableObjects.Add(mcsh, new SpawnableFloatingObject()
        {
            uniqueIndex = 5,
            hasNetworkBehaviour = true,
            recieveOnSpawnMessage = false,
            typeToSpawn = ObjectSpawnType.GameObject,
            prefab = asset.LoadAsset<GameObject>("Pickup_Hat_SteveHead"),
            minRotation = new Vector3(0, 0, 0),
            maxRotation = new Vector3(360, 360, 360),
            spawnChance = spawnChance
        });
        hats.Add(mcsh, asset.LoadAsset<GameObject>("mcsh_prefab"));

        Item_Base santa = asset.LoadAsset<Item_Base>("santa_so");
        RAPI.RegisterItem(santa);
        spawnableObjects.Add(santa, new SpawnableFloatingObject()
        {
            uniqueIndex = 6,
            hasNetworkBehaviour = true,
            recieveOnSpawnMessage = false,
            typeToSpawn = ObjectSpawnType.GameObject,
            prefab = asset.LoadAsset<GameObject>("Pickup_Hat_SantaHat"),
            minRotation = new Vector3(0, 0, 0),
            maxRotation = new Vector3(360, 360, 360),
            spawnChance = spawnChance
        });
        hats.Add(santa, asset.LoadAsset<GameObject>("santa_prefab"));

        Item_Base foundation = asset.LoadAsset<Item_Base>("foundation_so");
        RAPI.RegisterItem(foundation);
        spawnableObjects.Add(foundation, new SpawnableFloatingObject()
        {
            uniqueIndex = 7,
            hasNetworkBehaviour = true,
            recieveOnSpawnMessage = false,
            typeToSpawn = ObjectSpawnType.GameObject,
            prefab = asset.LoadAsset<GameObject>("Pickup_Hat_Foundation"),
            minRotation = new Vector3(0, 0, 0),
            maxRotation = new Vector3(360, 360, 360),
            spawnChance = spawnChance
        });
        hats.Add(foundation, asset.LoadAsset<GameObject>("foundation_prefab"));

        Item_Base shark = asset.LoadAsset<Item_Base>("shark_so");
        RAPI.RegisterItem(shark);
        spawnableObjects.Add(shark, new SpawnableFloatingObject()
        {
            uniqueIndex = 8,
            hasNetworkBehaviour = true,
            recieveOnSpawnMessage = false,
            typeToSpawn = ObjectSpawnType.GameObject,
            prefab = asset.LoadAsset<GameObject>("Pickup_Hat_Shark"),
            minRotation = new Vector3(0, 0, 0),
            maxRotation = new Vector3(360, 360, 360),
            spawnChance = spawnChance
        });
        hats.Add(shark, asset.LoadAsset<GameObject>("shark_prefab"));

        Item_Base hat = asset.LoadAsset<Item_Base>("hat_so");
        RAPI.RegisterItem(hat);
        spawnableObjects.Add(hat, new SpawnableFloatingObject()
        {
            uniqueIndex = 9,
            hasNetworkBehaviour = true,
            recieveOnSpawnMessage = false,
            typeToSpawn = ObjectSpawnType.GameObject,
            prefab = asset.LoadAsset<GameObject>("Pickup_Hat_Hat"),
            minRotation = new Vector3(0, 0, 0),
            maxRotation = new Vector3(360, 360, 360),
            spawnChance = spawnChance
        });
        hats.Add(hat, asset.LoadAsset<GameObject>("hat_prefab"));

        Item_Base mcslime = asset.LoadAsset<Item_Base>("mcslime_so");
        RAPI.RegisterItem(mcslime);
        spawnableObjects.Add(mcslime, new SpawnableFloatingObject()
        {
            uniqueIndex = 10,
            hasNetworkBehaviour = true,
            recieveOnSpawnMessage = false,
            typeToSpawn = ObjectSpawnType.GameObject,
            prefab = asset.LoadAsset<GameObject>("Pickup_Hat_SlimeHead"),
            minRotation = new Vector3(0, 0, 0),
            maxRotation = new Vector3(360, 360, 360),
            spawnChance = spawnChance
        });
        hats.Add(mcslime, asset.LoadAsset<GameObject>("mcslime_prefab"));

        Item_Base marsh = asset.LoadAsset<Item_Base>("marsh_so");
        RAPI.RegisterItem(marsh);
        spawnableObjects.Add(marsh, new SpawnableFloatingObject()
        {
            uniqueIndex = 11,
            hasNetworkBehaviour = true,
            recieveOnSpawnMessage = false,
            typeToSpawn = ObjectSpawnType.GameObject,
            prefab = asset.LoadAsset<GameObject>("Pickup_Hat_Marsh"),
            minRotation = new Vector3(0, 0, 0),
            maxRotation = new Vector3(360, 360, 360),
            spawnChance = spawnChance
        });
        hats.Add(marsh, asset.LoadAsset<GameObject>("marsh_prefab"));

        Item_Base bald = asset.LoadAsset<Item_Base>("bald_so");
        RAPI.RegisterItem(bald);
        spawnableObjects.Add(bald, new SpawnableFloatingObject()
        {
            uniqueIndex = 12,
            hasNetworkBehaviour = true,
            recieveOnSpawnMessage = false,
            typeToSpawn = ObjectSpawnType.GameObject,
            prefab = asset.LoadAsset<GameObject>("Pickup_Hat_Bald"),
            minRotation = new Vector3(0, 0, 0),
            maxRotation = new Vector3(360, 360, 360),
            spawnChance = spawnChance
        });
        hats.Add(bald, asset.LoadAsset<GameObject>("bald_prefab"));

        Item_Base propellerhat = asset.LoadAsset<Item_Base>("propellerhat_so");
        RAPI.RegisterItem(propellerhat);
        spawnableObjects.Add(propellerhat, new SpawnableFloatingObject()
        {
            uniqueIndex = 13,
            hasNetworkBehaviour = true,
            recieveOnSpawnMessage = false,
            typeToSpawn = ObjectSpawnType.GameObject,
            prefab = asset.LoadAsset<GameObject>("Pickup_Hat_PropellerHat"),
            minRotation = new Vector3(0, 0, 0),
            maxRotation = new Vector3(360, 360, 360),
            spawnChance = spawnChance
        });
        hats.Add(propellerhat, asset.LoadAsset<GameObject>("PropellerHat_prefab"));

        Debug.Log("HatsMod has been loaded!");
        notification.Close();
    }

    public void Update()
    {
        if (!Semih_Network.InLobbyScene)
        {
            if (spawner == null)
            {
                spawner = FindObjectOfType<ObjectSpawnerManager>();
            }
            else
            {
                hats.ToList().ForEach((hat) =>
                {
                    if (spawnableObjects.ContainsKey(hat.Key) && !spawner.itemSpawner.spawnableObjects.Contains(spawnableObjects[hat.Key]))
                    {
                        spawner.itemSpawner.spawnableObjects.Add(spawnableObjects[hat.Key]);
                    }
                });

            }
        }

    }

    public static void SetItemObject(Network_Player player)
    {
        foreach (KeyValuePair<Item_Base, GameObject> t in hats)
        {
            Transform parent = player.PlayerEquipment.transform;
            Transform parentObject = (Traverse.Create(player).Field("hatParent").GetValue() as Transform);

            if (!parentObject.Find("HatsMod_" + t.Key.UniqueName))
            {
                GameObject gameobject = GameObject.Instantiate(t.Value, parentObject);
                gameobject.name = "HatsMod_" + t.Key.UniqueName;
                gameobject.transform.localPosition = Vector3.zero;
                gameobject.transform.localRotation = Quaternion.Euler(0, 0, 90);
                gameobject.SetActive(false);
                GameObject hat = new GameObject("HatsMod_Equipment_" + t.Key.UniqueName);
                hat.transform.parent = parent;
                Equipment_Hat _hat = hat.AddComponent<Equipment_Hat>();
                _hat.equipableItem = t.Key;
                _hat.sendNetworkInfo = true;


                if (t.Key.UniqueName == "HM_MARSHMELLO")
                {
                    GameObject _gameobject = GameObject.Instantiate(t.Value, parentObject);
                    _gameobject.name = "HatsMod_" + t.Key.UniqueName;
                    _gameobject.transform.localPosition = Vector3.zero;
                    _gameobject.transform.localRotation = Quaternion.Euler(0, 0, 90);
                    _gameobject.transform.localScale = new Vector3(0, 0, 0);
                    _gameobject.SetActive(false);
                    AccessTools.Field(typeof(Equipment_Model), "localModel").SetValue(_hat, _gameobject.transform);
                }
                else
                {
                    AccessTools.Field(typeof(Equipment_Model), "localModel").SetValue(_hat, gameobject.transform);
                }


                AccessTools.Field(typeof(Equipment_Model), "remoteModel").SetValue(_hat, gameobject.transform);
                if (t.Key.UniqueName == "HM_SANTA")
                {
                    Traverse.Create(_hat).Field("hairStyle").SetValue(HairStyle.Half);
                }
                else
                {
                    Traverse.Create(_hat).Field("hairStyle").SetValue(HairStyle.Bald);
                }

                Equipment[] equipment = Traverse.Create(player.PlayerEquipment).Field("equipment").GetValue() as Equipment[];
                List<Equipment> list = equipment.OfType<Equipment>().ToList();
                list.Add(_hat);
                Traverse.Create(player.PlayerEquipment).Field("equipment").SetValue(list.ToArray());
            }
        }
    }
}

[HarmonyPatch(typeof(Semih_Network))]
[HarmonyPatch("AddPlayer")]
[HarmonyPatch(new Type[] { typeof(CSteamID), typeof(RGD_Settings_Character) })]
class Patch_AddPlayer1
{
    static void Postfix(Semih_Network __instance, CSteamID steamID)
    {
        Network_Player player = __instance.GetPlayerFromID(steamID);
        if (player != null)
        {
            HatsMod.SetItemObject(player);
        }
    }
}

[HarmonyPatch(typeof(Semih_Network))]
[HarmonyPatch("AddPlayer")]
[HarmonyPatch(new Type[] { typeof(Message_Player_Create) })]
class Patch_AddPlayer2
{
    static void Postfix(Semih_Network __instance, Message_Player_Create msg)
    {
        Network_Player player = __instance.GetPlayerFromID(msg.SteamID);
        if (player != null)
        {
            HatsMod.SetItemObject(player);
        }
    }
}

[HarmonyPatch(typeof(Helper))]
[HarmonyPatch("GetTerm")]
static class Localizations
{
    static bool Prefix(Helper __instance, string term, bool applyParameters, ref string __result)
    {
        switch (term)
        {
            case "PigHeadHatPickup":
                __result = "(HatsMod) Minecraft Pig Head";
                return false;
            case "SteveHeadHatPickup":
                __result = "(HatsMod) Minecraft Steve Head";
                return false;
            case "SantaHatPickup":
                __result = "(HatsMod) Santa hat";
                return false;
            case "FoundationHatPickup":
                __result = "(HatsMod) Foundation";
                return false;
            case "SharkHatPickup":
                __result = "(HatsMod) Alive Shark";
                return false;
            case "HatPickup":
                __result = "(HatsMod) A normal hat";
                return false;
            case "SlimeHeadHatPickup":
                __result = "(HatsMod) Minecraft Slime Head";
                return false;
            case "MarshHatPickup":
                __result = "(HatsMod) MarshMello Head";
                return false;
            case "BaldHatPickup":
                __result = "(HatsMod) Bald";
                return false;
            case "PropellerHatPickup":
                __result = "(HatsMod) Propeller Hat";
                return false;

        }
        return true;
    }
}